local mod = ...

-- Asset
mod:registerAssetId("models/Pasture1.fbx/Prefab/ConstructionSteps/Step_0.001", "PREFAB_LFPOST")

mod:registerAssetId("models/Pasture1.fbx/Prefab/PasturePart", "PREFAB_PASTURE1")
mod:registerAssetId("models/Pasture2.fbx/Prefab/PasturePart", "PREFAB_PASTURE2")
mod:registerAssetId("models/Silo1.fbx/Prefab/SiloPart", "PREFAB_SILO1")
mod:registerAssetId("models/Silo2.fbx/Prefab/SiloPart", "PREFAB_SILO2")
mod:registerAssetId("models/Shed1.fbx/Prefab/ShedPart", "PREFAB_SHED1")
mod:registerAssetId("models/Pen1.fbx/Prefab/PenPart", "PREFAB_PEN1")
mod:registerAssetId("models/Herd1.fbx/Prefab/HerdPart", "PREFAB_HERD1")
mod:registerAssetId("models/Herd2.fbx/Prefab/HerdPart", "PREFAB_HERD2")
mod:registerAssetId("models/Herd3.fbx/Prefab/HerdPart", "PREFAB_HERD3")
mod:registerAssetId("models/Herd4.fbx/Prefab/HerdPart", "PREFAB_HERD4")

mod:registerAssetId("models/Fence1.fbx/Prefab/FencePart", "PREFAB_FENCE1")
mod:registerAssetId("models/Fence2.fbx/Prefab/FencePart", "PREFAB_FENCE2")

mod:registerAssetId("models/Trough1.fbx/Prefab/TroughPart", "PREFAB_TROUGH1")
mod:registerAssetId("models/Trough2.fbx/Prefab/TroughPart", "PREFAB_TROUGH2")

mod:registerAssetId("models/Cow1.fbx/Prefab/HerdPart", "PREFAB_COW1")
mod:registerAssetId("models/Pig1.fbx/Prefab/HerdPart", "PREFAB_PIG1")
mod:registerAssetId("models/Sheep1.fbx/Prefab/HerdPart", "PREFAB_SHEEP1")
mod:registerAssetId("models/Goat1.fbx/Prefab/HerdPart", "PREFAB_GOAT1")

mod:registerAssetId("models/MilkCart.fbx/Prefab/CartPart", "PREFAB_MILKCART")
mod:registerAssetId("models/TallowGenerator.fbx/Prefab/TallowPart", "PREFAB_TALLOWGENERATOR")



-- Construction Asset
mod:registerAssetId("models/Pasture1.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_PASTURE1")
mod:registerAssetId("models/Pasture2.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_PASTURE2")
mod:registerAssetId("models/Silo1.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_SILO1")
mod:registerAssetId("models/Silo2.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_SILO2")
mod:registerAssetId("models/Shed1.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_SHED1")



-- Building Asset Processor
mod:registerAssetProcessor("models/Pasture1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Pasture2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Silo1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Silo2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Shed1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Pen1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Herd1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Herd2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Herd3.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Herd4.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Fence1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Fence2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/MilkCart.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/TallowGenerator.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Grounding
mod:registerPrefabComponent("models/Shed1.fbx/Prefab/ShedPart", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Shed1.fbx/Prefab/ShedPart/Bucket.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Shed1.fbx/Prefab/ShedPart/Bench.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Shed1.fbx/Prefab/ShedPart/Jug.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Silo1.fbx/Prefab/SiloPart", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Silo2.fbx/Prefab/SiloPart", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Pen1.fbx/Prefab/PenPart/Bucket.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/MilkCart.fbx/Prefab/CartPart", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/TallowGenerator.fbx/Prefab/TallowPart", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Trough1.fbx/Prefab/TroughPart/Trough.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Trough2.fbx/Prefab/TroughPart/Trough.001", {DataType = "COMP_GROUNDED"})

for i=1, 3, 1 do
	mod:registerPrefabComponent("models/Fence1.fbx/Prefab/FencePart/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/Fence2.fbx/Prefab/FencePart/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 4, 1 do
	mod:registerPrefabComponent("models/Herd1.fbx/Prefab/HerdPart/Animal." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 5, 1 do
	mod:registerPrefabComponent("models/Herd4.fbx/Prefab/HerdPart/Animal." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 6, 1 do
	mod:registerPrefabComponent("models/Shed1.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 7, 1 do
	mod:registerPrefabComponent("models/Pasture1.fbx/Prefab/PasturePart/Post." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/Pasture1.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 8, 1 do
	mod:registerPrefabComponent("models/Herd2.fbx/Prefab/HerdPart/Animal." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 10, 1 do
	mod:registerPrefabComponent("models/Pasture2.fbx/Prefab/ConstructionSteps/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/Pasture2.fbx/Prefab/PasturePart/Post." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/Herd3.fbx/Prefab/HerdPart/Animal." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 11, 1 do
	mod:registerPrefabComponent("models/Pen1.fbx/Prefab/PenPart/Fence." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end



-- Collider Platform (climbable mesh)  -------------------------------------------------------------------------------------
mod:configurePrefabFlagList("models/Silo1.fbx/Prefab/SiloPart", { "PLATFORM" })
mod:configurePrefabFlagList("models/Silo2.fbx/Prefab/SiloPart", { "PLATFORM" })



-- Paths: Milk cart -------------------------------------------------------------------------------------
mod:registerAssetId("models/MilkCart.fbx/Prefab/CartPart/PATH_A_1", "PATH_MILKCART_A1")
mod:registerAssetId("models/MilkCart.fbx/Prefab/CartPart/PATH_B_1", "PATH_MILKCART_B1")
mod:registerAssetId("models/MilkCart.fbx/Prefab/CartPart/PATH_C_1", "PATH_MILKCART_C1")
mod:registerAssetId("models/MilkCart.fbx/Prefab/CartPart/PATH_D_1", "PATH_MILKCART_D1")

mod:registerPrefabComponent("models/MilkCart.fbx/Prefab/CartPart", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "PATH_MILKCART_B1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MILKCART_A1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MILKCART_C1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MILKCART_D1" }
        },
    }
})



-- Building part type
mod:registerEnumValue("BUILDING_PART_TYPE", "PASTURE")
mod:registerEnumValue("BUILDING_PART_TYPE", "SILO")
mod:registerEnumValue("BUILDING_PART_TYPE", "SHED")
mod:registerEnumValue("BUILDING_PART_TYPE", "PEN")
mod:registerEnumValue("BUILDING_PART_TYPE", "HERD")
mod:registerEnumValue("BUILDING_PART_TYPE", "FENCE")
mod:registerEnumValue("BUILDING_PART_TYPE", "DECORATION")



-- Resource Type: Livestock Farm
-- mod:registerEnumValue( "RESOURCE_TYPE", "LIVESTOCKFARM_RESOURCE_TYPE" )



-- Building part type
mod:registerEnumValue("BUILDING_PART_TYPE", "COUNTER")



-- Job: Livestock Farmer -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "LIVESTOCKFARMER_JOB",
	JobName = "LIVESTOCKFARMER_JOB_NAME",
	JobDescription = "LIVESTOCKFARMER_JOB_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
	-- DefaultBehavior = "LIVESTOCKFARM_BEHAVIOR_TREE",
    ProductionDelay = 70.0, -- default 30
    -- ProductionDelay = 30.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
		RightHandObject = {
			DataType = "HAND_OBJECT",
			Model = "PREFAB_TOOL_SHEPHERD_STICK"
		},
		IdleAnimation = "GUARD"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "LIVESTOCKFARMER_JOB"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "LIVESTOCKFARMER_JOB"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "LIVESTOCKFARMER_JOB"
    }
})



-- Resource: Cattle -------------------------------------------------------------------------------------
-- mod:registerAssetId("icons/Cattle.png", "ICON_CATTLE")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_CATTLE",
-- 	ResourceName = "RESOURCE_CATTLE_NAME",
-- 	Icon = "ICON_CATTLE",
-- 	ResourceTypeList = { "RESOURCE" },
-- 	IsTradable = false,
-- 	-- ResourceLayoutType = "CRATES",
-- 	-- VillagerBuyingPrice = { Resource = "GOLD", Quantity = 20 },
-- 	DisplayInInventory = false
-- })



-- Resource: Pig -------------------------------------------------------------------------------------
-- mod:registerAssetId("icons/Pig.png", "ICON_PIG")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_PIG",
-- 	ResourceName = "RESOURCE_PIG_NAME",
-- 	Icon = "ICON_PIG",
-- 	ResourceTypeList = { "RESOURCE" },
-- 	IsTradable = false,
-- 	-- ResourceLayoutType = "CRATES",
-- 	-- VillagerBuyingPrice = { Resource = "GOLD", Quantity = 20 },
-- 	DisplayInInventory = false
-- })



-- Resource: Sheep -------------------------------------------------------------------------------------
-- mod:registerAssetId("icons/Sheep.png", "ICON_SHEEP")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_SHEEP",
-- 	ResourceName = "RESOURCE_SHEEP_NAME",
-- 	Icon = "ICON_SHEEP",
-- 	ResourceTypeList = { "RESOURCE" },
-- 	IsTradable = false,
-- 	-- ResourceLayoutType = "CRATES",
-- 	-- VillagerBuyingPrice = { Resource = "GOLD", Quantity = 20 },
-- 	DisplayInInventory = false
-- })



-- Resource: Goat -------------------------------------------------------------------------------------
-- mod:registerAssetId("icons/Goat.png", "ICON_GOAT")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_GOAT",
-- 	ResourceName = "RESOURCE_GOAT_NAME",
-- 	Icon = "ICON_GOAT",
-- 	ResourceTypeList = { "RESOURCE" },
-- 	IsTradable = false,
-- 	-- ResourceLayoutType = "CRATES",
-- 	-- VillagerBuyingPrice = { Resource = "GOLD", Quantity = 20 },
-- 	DisplayInInventory = false
-- })



-- Resource: Animal Feed -------------------------------------------------------------------------------------
-- mod:registerAssetId("icons/Feed.png", "ICON_FEED")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_FEED",
-- 	ResourceName = "RESOURCE_FEED_NAME",
-- 	Icon = "ICON_FEED",
-- 	ResourceTypeList = { "RESOURCE" },
-- 	IsTradable = false,
-- 	-- ResourceLayoutType = "CRATES",
-- 	-- VillagerBuyingPrice = { Resource = "GOLD", Quantity = 20 },
-- 	DisplayInInventory = false
-- })



-- Resource: Carcass -------------------------------------------------------------------------------------
-- Now available in the common resources mod

-- mod:registerAssetId("icons/Carcass.png", "ICON_CARCASS")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "CARCASS_RESOURCE",
-- 	ResourceName = "CARCASS_RESOURCE_NAME",
-- 	Icon = "ICON_CARCASS",
-- 	ResourceTypeList = { "RESOURCE_FOOD" },
-- 	IsTradable = true,
-- 	ResourceLayoutType = "CRATES",
-- 	-- VillagerBuyingPrice = { Resource = "GOLD", Quantity = 6 },
-- 	DisplayInInventory = true
-- })



-- Resource: Tallow -------------------------------------------------------------------------------------

-- mod:registerAssetId("icons/Tallow.png", "ICON_TALLOW")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_TALLOW",
-- 	ResourceName = "RESOURCE_TALLOW_NAME",
-- 	Icon = "ICON_TALLOW",
-- 	ResourceTypeList = { "RESOURCE" },
-- 	IsTradable = false,
-- 	ResourceLayoutType = "CRATES",
-- 	-- VillagerBuyingPrice = { Resource = "GOLD", Quantity = 6 },
-- 	DisplayInInventory = false
-- })



-- Resource: Leather (override) -------------------------------------------------------------------------------------

mod:override({
	Id = "LEATHER",
	IsTradable = true,
	ResourceLayoutType = "CRATES",
	ResourceTypeList = { "RESOURCE" },
	VillagerBuyingPrice = nil, --{ Resource = "GOLD", Quantity = 10 },
	DisplayInInventory = true
})



-- Resource: Milk (override) -------------------------------------------------------------------------------------

mod:override({
	Id = "MILK",
	IsTradable = true,
	ResourceLayoutType = "CRATES",
	ResourceTypeList = { "RESOURCE_FOOD", "FOOD", "FOOD_SELLABLE" },
	-- ResourceTypeList = { "RESOURCE_FOOD", "FOOD" },
	VillagerBuyingPrice = { Resource = "GOLD", Quantity = 6 },
	DisplayInInventory = true
})



-- Building Function: Cattle -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "LIVESTOCKFARM_CATTLE_FUNCTION",
    Name = "LIVESTOCKFARM_CATTLE_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "LIVESTOCKFARMER_JOB", 
        Behavior = "BEHAVIOR_WORK"
        -- Behavior = "LIVESTOCKFARM_BEHAVIOR_TREE"
    },
    InputInventoryCapacity = {
		{ Resource = "WATER", Quantity = 5 },
		{ Resource = "RESOURCE_FEED", Quantity = 5 },
	},
    ResourceListNeeded = {
		{ Resource = "WATER", Quantity = 1 },
		{ Resource = "RESOURCE_FEED", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_CATTLE", Quantity = 1 },
		{ Resource = "RESOURCE_DUNG", Quantity = 1 },
	}

})



-- Building Function: Pigs -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "LIVESTOCKFARM_PIG_FUNCTION",
    Name = "LIVESTOCKFARM_PIG_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "LIVESTOCKFARMER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "WATER", Quantity = 5 },
		{ Resource = "RESOURCE_FEED", Quantity = 5 },
	},
    ResourceListNeeded = {
		{ Resource = "WATER", Quantity = 1 },
		{ Resource = "RESOURCE_FEED", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_PIG", Quantity = 1 },
		{ Resource = "RESOURCE_DUNG", Quantity = 1 },
	}
})



-- Building Function: Sheep -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "LIVESTOCKFARM_SHEEP_FUNCTION",
    Name = "LIVESTOCKFARM_SHEEP_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "LIVESTOCKFARMER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "WATER", Quantity = 5 },
		{ Resource = "RESOURCE_FEED", Quantity = 5 },
	},
    ResourceListNeeded = {
		{ Resource = "WATER", Quantity = 1 },
		{ Resource = "RESOURCE_FEED", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_SHEEP", Quantity = 1 },
		{ Resource = "RESOURCE_DUNG", Quantity = 1 },
	}
})



-- Building Function: Animal Feed -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "FEED_FUNCTION",
    Name = "FEED_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "LIVESTOCKFARMER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "WHEAT", Quantity = 50 },
		{ Resource = "RESOURCE_VEGETABLE", Quantity = 50 },
	},
    ResourceListNeeded = {
		{ Resource = "WHEAT", Quantity = 15 },
		{ Resource = "RESOURCE_VEGETABLE", Quantity = 15 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_FEED", Quantity = 20 },
	}
})



-- Building Function: Goat -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "LIVESTOCKFARM_GOAT_FUNCTION",
    Name = "LIVESTOCKFARM_GOAT_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "LIVESTOCKFARMER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "WATER", Quantity = 5 },
		{ Resource = "RESOURCE_FEED", Quantity = 5 },
	},
    ResourceListNeeded = {
		{ Resource = "WATER", Quantity = 1 },
		{ Resource = "RESOURCE_FEED", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_GOAT", Quantity = 1 },
		{ Resource = "RESOURCE_DUNG", Quantity = 1 },
	}
})



-- Building Function Assignable: Slaughter -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "SLAUGHTER_FUNCTION_ASSIGNABLE",
	Name = "SLAUGHTER_FUNCTION_ASSIGNABLE_NAME",
	AuthorizedFunctionList = "SLAUGHTER_FUNCTION_LIST"
})



-- Building Function List: Slaughter -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "SLAUGHTER_FUNCTION_LIST",
	AssetFunctionList = {
		"SLAUGHTERCATTLE_FUNCTION",
		"SLAUGHTERPIG_FUNCTION",
		"SLAUGHTERSHEEP_FUNCTION",
		"SLAUGHTERGOAT_FUNCTION",
		"SHEARSHEEP_FUNCTION",
	}
})



-- Building Function Assignable: Milking -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "MILK_FUNCTION_ASSIGNABLE",
	Name = "MILK_FUNCTION_ASSIGNABLE_NAME",
	AuthorizedFunctionList = "MILK_FUNCTION_LIST"
})



-- Building Function List: Milking -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "MILK_FUNCTION_LIST",
	AssetFunctionList = {
		"MILKCATTLE_FUNCTION",
		"MILKSHEEP_FUNCTION",
		"MILKGOAT_FUNCTION",
	}
})



-- Building Function: Slaughter Cattle  -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "SLAUGHTERCATTLE_FUNCTION",
    Name = "SLAUGHTERCATTLE_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "LIVESTOCKFARMER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_CATTLE", Quantity = 5 }
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_CATTLE", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "BV1_CARCASS", Quantity = 1 },
		-- { Resource = "LEATHER", Quantity = 1 },
	}
})



-- Building Function: Slaughter Pigs  -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "SLAUGHTERPIG_FUNCTION",
    Name = "SLAUGHTERPIG_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "LIVESTOCKFARMER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_PIG", Quantity = 5 }
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_PIG", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "BV1_CARCASS", Quantity = 1 },
		-- { Resource = "LEATHER", Quantity = 1 },
	}
})



-- Building Function: Slaughter Sheep  -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "SLAUGHTERSHEEP_FUNCTION",
    Name = "SLAUGHTERSHEEP_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "LIVESTOCKFARMER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_SHEEP", Quantity = 5 }
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_SHEEP", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "BV1_CARCASS", Quantity = 1 },
		-- { Resource = "LEATHER", Quantity = 1 },
	}
})



-- Building Function: Slaughter Goats  -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "SLAUGHTERGOAT_FUNCTION",
    Name = "SLAUGHTERGOAT_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "LIVESTOCKFARMER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_GOAT", Quantity = 5 }
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_GOAT", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "BV1_CARCASS", Quantity = 1 },
		-- { Resource = "LEATHER", Quantity = 1 },
	}
})



-- Building Function: Shear Sheep  -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "SHEARSHEEP_FUNCTION",
    Name = "SHEARSHEEP_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "LIVESTOCKFARMER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_SHEEP", Quantity = 5 }
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_SHEEP", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "WOOL", Quantity = 5 },
	}
})



-- Building Function: Milk Cows  -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "MILKCATTLE_FUNCTION",
    Name = "MILKCATTLE_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "LIVESTOCKFARMER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_CATTLE", Quantity = 5 }
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_CATTLE", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "MILK", Quantity = 5 },
	}
})



-- Building Function: Milk Sheep  -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "MILKSHEEP_FUNCTION",
    Name = "MILKSHEEP_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "LIVESTOCKFARMER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_SHEEP", Quantity = 5 }
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_SHEEP", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "MILK", Quantity = 2 },
	}
})



-- Building Function: Milk Goats  -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "MILKGOAT_FUNCTION",
    Name = "MILKGOAT_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "LIVESTOCKFARMER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
    InputInventoryCapacity = {
		{ Resource = "RESOURCE_GOAT", Quantity = 5 }
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_GOAT", Quantity = 1 }
	},
    ResourceProduced = {
		{ Resource = "MILK", Quantity = 2 },
	}
})



-- -- Resource: Milk (Sellable) -------------------------------------------------------------------------------------
-- -- I create a second resource that appears the same as Milk, but is different. This is to avoid an issue with Times and Seasons mod

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "RESOURCE_MILK_SELL",
-- 	ResourceName = "MILK",
-- 	Icon = "MILK",
--     ResourceTypeList = { "FOOD", "LIVESTOCKFARM_RESOURCE_TYPE", "FOOD_SELLABLE" },
-- 	IsTradable = false,
-- 	ResourceLayoutType = "CRATES",
--     VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 6 },
-- 	DisplayInInventory = false
-- })



-- Building Function: Farm Milk Cart (sell directly to villagers) -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "MILKCART_FUNCTION",
    Name = "MILKCART_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "MARKET_TENDER", 
        Behavior = "BEHAVIOR_WORK"
    },
	TypeList = { "LIVESTOCKFARM_RESOURCE_TYPE" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 50,
	InputInventoryCapacity = {
		{ Resource = "MILK", Quantity = 50 },
	},
    ResourceListNeeded = {
		{ Resource = "MILK", Quantity = 10 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_MILK_SELL", Quantity = 10 },
		-- { Resource = "MILK", Quantity = 10 },
	}
})



-- Building Function: Tallow  -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "TALLOW_FUNCTION",
	Name = "TALLOW_FUNCTION_NAME",
	ResourceGenerated = "RESOURCE_TALLOW",
	IsForConsumer = false,
	IsInfinite = true
})



-- Building: Livestock Farm -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "LIVESTOCKFARM",
	Name = "LIVESTOCKFARM_NAME",
	Description = "LIVESTOCKFARM_DESC",
	BuildingType = "GENERAL",
	AssetCoreBuildingPart = "LIVESTOCKFARM_POST_PART",
	BuildingPartSetList = {
		{
			Name = "LIVESTOCKFARM_SET1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_LIVESTOCK_FARM1",
				"PASTURE1_PART",
				"PASTURE2_PART",
			}
		},
		{
			Name = "LIVESTOCKFARM_SET7_NAME",
			BuildingPartList = { 
				"SILO2_PART",
				"SILO1_PART",
			}
		},
		{
			Name = "LIVESTOCKFARM_SET2_NAME",
			BuildingPartList = { 
				"SHED1_PART",
			}
		},
		{
			Name = "LIVESTOCKFARM_SET3_NAME",
			BuildingPartList = { 
				"PEN1_PART",
				"TALLOWGENERATOR_PART",
			}
		},
		{
			Name = "LIVESTOCKFARM_SET4_NAME",
			BuildingPartList = { 
				"HERD1_PART",
				"HERD2_PART",
				"HERD3_PART",
				"HERD4_PART",
			}
		},
		{
			Name = "LIVESTOCKFARM_SET5_NAME",
			BuildingPartList = { 
				"FENCE1_PART",
				"FENCE2_PART",
			}
		},
		{
			Name = "LIVESTOCKFARM_SET8_NAME",
			BuildingPartList = { 
				"MILKCART_PART",
			}
		},
		{
			Name = "LIVESTOCKFARM_SET6_NAME",
			BuildingPartList = { 
				"TROUGH1_PART",
				"TROUGH2_PART",
				"COW1_PART",
				"PIG1_PART",
				"SHEEP1_PART",
				"GOAT1_PART",
			}
		}
	},	
	-- RequiredPartList = {
		-- { Category = "PASTURE", Min = 1, Max = 1 },
		-- { Category = "SILO", Min = 1, Max = 1 },
		-- { Category = "SHED", Min = 1, Max = 1 },
		-- { Category = "PEN", Min = 1, Max = 1 },
		-- { Category = "HERD", Min = 1, Max = 1 },
	-- },
	VillagerRequired = { Status = "COMMONER", Quantity = 5 },
	IsEditable = true
})



-- Building Part: Post -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "LIVESTOCKFARM_POST_PART",
	Name = "LIVESTOCKFARM_NAME", 
	Description = "LIVESTOCKFARM_DESC",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_LFPOST"
	},
	IsVisibleWhenBuilt = false
})



-- Building Part: Pasture 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "PASTURE1_PART",
	Name = "PASTURE1_PART_NAME", 
	Category = "PASTURE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_PASTURE1"
	},
	ConstructionVisual = "PREFAB_CONSTR_PASTURE1",
	-- BuildingZone = { 
    --     ZoneEntryList = {
    --         { 
    --             Polygon = polygon.createRectangle( {20, 13}, {0.0, 0.0} ),
    --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
	-- 		}
	-- 	}
	-- },
	-- AssetBuildingFunction = "CATTLEFARM_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
            { Resource = "WATER", Quantity = 2 },
		}
	}
})



-- Building Part: Pasture 2 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "PASTURE2_PART",
	Name = "PASTURE2_PART_NAME", 
	Category = "PASTURE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_PASTURE2"
	},
	ConstructionVisual = "PREFAB_CONSTR_PASTURE2",
	-- BuildingZone = { 
    --     ZoneEntryList = {
    --         { 
    --             Polygon = polygon.createRectangle( {20, 13}, {0.0, 0.0} ),
    --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
	-- 		}
	-- 	}
	-- },
	-- AssetBuildingFunction = "CATTLEFARM_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
            { Resource = "WATER", Quantity = 2 },
		}
	}
})



-- Building Part: Silo 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "SILO1_PART",
	Name = "SILO1_PART_NAME", 
	Category = "SILO",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_SILO1"
	},
	ConstructionVisual = "PREFAB_CONSTR_SILO1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {6.5, 4.5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "FEED_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "STONE", Quantity = 1 },
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "PLANK", Quantity = 2 },
		}
	}
})



-- Building Part: Silo 2 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "SILO2_PART",
	Name = "SILO2_PART_NAME", 
	Category = "SILO",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_SILO2"
	},
	ConstructionVisual = "PREFAB_CONSTR_SILO2",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {6.5, 4.5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "FEED_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "STONE", Quantity = 1 },
            { Resource = "WOOD", Quantity = 4 },
            { Resource = "PLANK", Quantity = 2 },
		}
	}
})



-- Building Part: Shed 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "SHED1_PART",
	Name = "SHED1_PART_NAME", 
	Category = "SHED",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_SHED1"
	},
	ConstructionVisual = "PREFAB_CONSTR_SHED1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {6.5, 4.5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "MILK_FUNCTION_ASSIGNABLE",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
            { Resource = "PLANK", Quantity = 8 },
		}
	},
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "SUBSTRACT",
		Radius = 20.0,
		Value = 0.5
	} }
})



-- Building Part: Pen 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "PEN1_PART",
	Name = "PEN1_PART_NAME", 
	Category = "PEN",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_PEN1"
	},
	-- ConstructionVisual = "PREFAB_PEN1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {6.5, 4.5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "SLAUGHTER_FUNCTION_ASSIGNABLE",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 3 },
		}
	},
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "SUBSTRACT",
		Radius = 20.0,
		Value = 0.5
	} }
})



-- Building Part: Herd 1 (cattle) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "HERD1_PART",
	Name = "HERD1_PART_NAME", 
	Category = "HERD",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HERD1"
	},
	-- ConstructionVisual = "PREFAB_HERD1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 3, {0.0, 0.0}, 12 ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = false } 
			}
		}
	},
	AssetBuildingFunction = "LIVESTOCKFARM_CATTLE_FUNCTION",
	-- HasMaximumInstancePerBuilding = true,
	-- MaximumInstancePerBuilding = 2,
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 40 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
		RessourcesNeeded = {
            -- { Resource = "STONE", Quantity = 10 },
            -- { Resource = "WOOD", Quantity = 10 },
            -- { Resource = "PLANK", Quantity = 10 },
            -- { Resource = "TOOL", Quantity = 5 }
		}
	},
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "SUBSTRACT",
		Radius = 20.0,
		Value = 0.5
	} }
})



-- Building Part: Herd 2 (pigs) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "HERD2_PART",
	Name = "HERD2_PART_NAME", 
	Category = "HERD",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HERD2"
	},
	-- ConstructionVisual = "PREFAB_HERD1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 3, {0.0, 0.0}, 12 ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = false } 
			}
		}
	},
	AssetBuildingFunction = "LIVESTOCKFARM_PIG_FUNCTION",
	-- HasMaximumInstancePerBuilding = true,
	-- MaximumInstancePerBuilding = 2,
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 40 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
		RessourcesNeeded = {
            -- { Resource = "STONE", Quantity = 10 },
            -- { Resource = "WOOD", Quantity = 10 },
            -- { Resource = "PLANK", Quantity = 10 },
            -- { Resource = "TOOL", Quantity = 5 }
		}
	},
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "SUBSTRACT",
		Radius = 20.0,
		Value = 0.5
	} }
})



-- Building Part: Herd 3 (sheep) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "HERD3_PART",
	Name = "HERD3_PART_NAME", 
	Category = "HERD",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HERD3"
	},
	-- ConstructionVisual = "PREFAB_HERD1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 3, {0.0, 0.0}, 12 ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = false } 
			}
		}
	},
	AssetBuildingFunction = "LIVESTOCKFARM_SHEEP_FUNCTION",
	-- HasMaximumInstancePerBuilding = true,
	-- MaximumInstancePerBuilding = 2,
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 40 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
		RessourcesNeeded = {
            -- { Resource = "STONE", Quantity = 10 },
            -- { Resource = "WOOD", Quantity = 10 },
            -- { Resource = "PLANK", Quantity = 10 },
            -- { Resource = "TOOL", Quantity = 5 }
		}
	},
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "SUBSTRACT",
		Radius = 20.0,
		Value = 0.5
	} }
})



-- Building Part: Herd 4 (goats) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "HERD4_PART",
	Name = "HERD4_PART_NAME", 
	Category = "HERD",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HERD4"
	},
	-- ConstructionVisual = "PREFAB_HERD1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 3, {0.0, 0.0}, 12 ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = false } 
			}
		}
	},
	AssetBuildingFunction = "LIVESTOCKFARM_GOAT_FUNCTION",
	-- HasMaximumInstancePerBuilding = true,
	-- MaximumInstancePerBuilding = 2,
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 40 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
		RessourcesNeeded = {
            -- { Resource = "STONE", Quantity = 10 },
            -- { Resource = "WOOD", Quantity = 10 },
            -- { Resource = "PLANK", Quantity = 10 },
            -- { Resource = "TOOL", Quantity = 5 }
		}
	},
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "SUBSTRACT",
		Radius = 20.0,
		Value = 0.5
	} }
})



-- Building Part: Fence 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "FENCE1_PART",
	Name = "FENCE1_PART_NAME", 
	Category = "FENCE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_FENCE1"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_SHED1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {6.75, 0.6}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = false } 
			}
		}
	},
	-- AssetBuildingFunction = "CATTLEFARM_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 1 },
		}
	}
})



-- Building Part: Fence 2 (gate) -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "FENCE2_PART",
	Name = "FENCE2_PART_NAME", 
	Category = "FENCE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_FENCE2"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_SHED1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2.5, 0.6}, {2.5, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = false } 
			},
            { 
                Polygon = polygon.createRectangle( {2.5, 0.6}, {-2.5, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = false } 
			}
		}
	},
	-- AssetBuildingFunction = "CATTLEFARM_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 1 },
		}
	}
})



-- Building Part: Trough 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "TROUGH1_PART",
	Name = "TROUGH1_PART_NAME", 
	Category = "DECORATION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TROUGH1"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_SHED1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2.25, 0.75}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	-- AssetBuildingFunction = "CATTLEFARM_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 1 },
		}
	}
})



-- Building Part: Trough 2 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "TROUGH2_PART",
	Name = "TROUGH2_PART_NAME", 
	Category = "DECORATION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TROUGH2"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_SHED1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2.25, 0.75}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	-- AssetBuildingFunction = "CATTLEFARM_FUNCTION",
	Cost = {
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 1 },
		}
	}
})



-- Building Part: Cow 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "COW1_PART",
	Name = "COW1_PART_NAME", 
	Category = "DECORATION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_COW1"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_SHED1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.0, 2.0}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = false } 
			}
		}
	},
	-- AssetBuildingFunction = "CATTLEFARM_FUNCTION",
	Cost = {
		-- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 1 },
		-- }
	}
})



-- Building Part: Pig 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "PIG1_PART",
	Name = "PIG1_PART_NAME", 
	Category = "DECORATION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_PIG1"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_SHED1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {0.75, 1.75}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = false } 
			}
		}
	},
	-- AssetBuildingFunction = "CATTLEFARM_FUNCTION",
	Cost = {
		-- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 1 },
		-- }
	}
})



-- Building Part: Sheep 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "SHEEP1_PART",
	Name = "SHEEP1_PART_NAME", 
	Category = "DECORATION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_SHEEP1"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_SHED1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {0.75, 1.75}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = false } 
			}
		}
	},
	-- AssetBuildingFunction = "CATTLEFARM_FUNCTION",
	Cost = {
		-- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 1 },
		-- }
	}
})



-- Building Part: Goat 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "GOAT1_PART",
	Name = "GOAT1_PART_NAME", 
	Category = "DECORATION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_GOAT1"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_SHED1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {0.75, 1.75}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = false } 
			}
		}
	},
	-- AssetBuildingFunction = "CATTLEFARM_FUNCTION",
	Cost = {
		-- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 1 },
		-- }
	}
})



-- Building Part: Milk Cart -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "MILKCART_PART",
	Name = "MILKCART_PART_NAME", 
	Category = "COUNTER",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_MILKCART"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_BUTCHERCOUNTER",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.5, 1.5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "MILKCART_FUNCTION",
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 1 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 1 } },
		RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 2 }
		}
	},
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "ADD",
		Radius = 25.0,
		Value = 0.5
	} }
})



-- Building Part: Tallow Generator -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "TALLOWGENERATOR_PART",
	Name = "TALLOWGENERATOR_PART_NAME", 
	Category = "PEN",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TALLOWGENERATOR"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_SHED1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.5, {0.0, 0.0}, 12),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "TALLOW_FUNCTION",
	Cost = {
		-- RessourcesNeeded = {
        --     { Resource = "WOOD", Quantity = 1 },
		-- }
	},
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "SUBSTRACT",
		Radius = 10.0,
		Value = 0.25
	} }

})